/**
 * Autogenerated by Thrift Compiler (0.10.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
#ifndef ChatService_H
#define ChatService_H

#include <thrift/TDispatchProcessor.h>
#include <thrift/async/TConcurrentClientSyncInfo.h>
#include "Service_types.h"

namespace chatgen {

#ifdef _WIN32
  #pragma warning( push )
  #pragma warning (disable : 4250 ) //inheriting methods via dominance 
#endif

class ChatServiceIf {
 public:
  virtual ~ChatServiceIf() {}
  virtual void Connect(const std::string& userName) = 0;
  virtual void Ping() = 0;
  virtual void Disconnect() = 0;
  virtual void GetUserList(std::set<std::string> & _return) = 0;
  virtual void SendDirectMessage(const std::string& message, const std::string& toUserName) = 0;
  virtual void SendBroadcastMessage(const std::string& message) = 0;
};

class ChatServiceIfFactory {
 public:
  typedef ChatServiceIf Handler;

  virtual ~ChatServiceIfFactory() {}

  virtual ChatServiceIf* getHandler(const ::apache::thrift::TConnectionInfo& connInfo) = 0;
  virtual void releaseHandler(ChatServiceIf* /* handler */) = 0;
};

class ChatServiceIfSingletonFactory : virtual public ChatServiceIfFactory {
 public:
  ChatServiceIfSingletonFactory(const boost::shared_ptr<ChatServiceIf>& iface) : iface_(iface) {}
  virtual ~ChatServiceIfSingletonFactory() {}

  virtual ChatServiceIf* getHandler(const ::apache::thrift::TConnectionInfo&) {
    return iface_.get();
  }
  virtual void releaseHandler(ChatServiceIf* /* handler */) {}

 protected:
  boost::shared_ptr<ChatServiceIf> iface_;
};

class ChatServiceNull : virtual public ChatServiceIf {
 public:
  virtual ~ChatServiceNull() {}
  void Connect(const std::string& /* userName */) {
    return;
  }
  void Ping() {
    return;
  }
  void Disconnect() {
    return;
  }
  void GetUserList(std::set<std::string> & /* _return */) {
    return;
  }
  void SendDirectMessage(const std::string& /* message */, const std::string& /* toUserName */) {
    return;
  }
  void SendBroadcastMessage(const std::string& /* message */) {
    return;
  }
};

typedef struct _ChatService_Connect_args__isset {
  _ChatService_Connect_args__isset() : userName(false) {}
  bool userName :1;
} _ChatService_Connect_args__isset;

class ChatService_Connect_args {
 public:

  ChatService_Connect_args(const ChatService_Connect_args&);
  ChatService_Connect_args& operator=(const ChatService_Connect_args&);
  ChatService_Connect_args() : userName() {
  }

  virtual ~ChatService_Connect_args() throw();
  std::string userName;

  _ChatService_Connect_args__isset __isset;

  void __set_userName(const std::string& val);

  bool operator == (const ChatService_Connect_args & rhs) const
  {
    if (!(userName == rhs.userName))
      return false;
    return true;
  }
  bool operator != (const ChatService_Connect_args &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const ChatService_Connect_args & ) const;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};


class ChatService_Connect_pargs {
 public:


  virtual ~ChatService_Connect_pargs() throw();
  const std::string* userName;

  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};

typedef struct _ChatService_Connect_result__isset {
  _ChatService_Connect_result__isset() : ce(false), ie(false) {}
  bool ce :1;
  bool ie :1;
} _ChatService_Connect_result__isset;

class ChatService_Connect_result {
 public:

  ChatService_Connect_result(const ChatService_Connect_result&);
  ChatService_Connect_result& operator=(const ChatService_Connect_result&);
  ChatService_Connect_result() {
  }

  virtual ~ChatService_Connect_result() throw();
  ConnectionError ce;
  InternalError ie;

  _ChatService_Connect_result__isset __isset;

  void __set_ce(const ConnectionError& val);

  void __set_ie(const InternalError& val);

  bool operator == (const ChatService_Connect_result & rhs) const
  {
    if (!(ce == rhs.ce))
      return false;
    if (!(ie == rhs.ie))
      return false;
    return true;
  }
  bool operator != (const ChatService_Connect_result &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const ChatService_Connect_result & ) const;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};

typedef struct _ChatService_Connect_presult__isset {
  _ChatService_Connect_presult__isset() : ce(false), ie(false) {}
  bool ce :1;
  bool ie :1;
} _ChatService_Connect_presult__isset;

class ChatService_Connect_presult {
 public:


  virtual ~ChatService_Connect_presult() throw();
  ConnectionError ce;
  InternalError ie;

  _ChatService_Connect_presult__isset __isset;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);

};


class ChatService_Ping_args {
 public:

  ChatService_Ping_args(const ChatService_Ping_args&);
  ChatService_Ping_args& operator=(const ChatService_Ping_args&);
  ChatService_Ping_args() {
  }

  virtual ~ChatService_Ping_args() throw();

  bool operator == (const ChatService_Ping_args & /* rhs */) const
  {
    return true;
  }
  bool operator != (const ChatService_Ping_args &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const ChatService_Ping_args & ) const;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};


class ChatService_Ping_pargs {
 public:


  virtual ~ChatService_Ping_pargs() throw();

  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};


class ChatService_Disconnect_args {
 public:

  ChatService_Disconnect_args(const ChatService_Disconnect_args&);
  ChatService_Disconnect_args& operator=(const ChatService_Disconnect_args&);
  ChatService_Disconnect_args() {
  }

  virtual ~ChatService_Disconnect_args() throw();

  bool operator == (const ChatService_Disconnect_args & /* rhs */) const
  {
    return true;
  }
  bool operator != (const ChatService_Disconnect_args &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const ChatService_Disconnect_args & ) const;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};


class ChatService_Disconnect_pargs {
 public:


  virtual ~ChatService_Disconnect_pargs() throw();

  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};


class ChatService_GetUserList_args {
 public:

  ChatService_GetUserList_args(const ChatService_GetUserList_args&);
  ChatService_GetUserList_args& operator=(const ChatService_GetUserList_args&);
  ChatService_GetUserList_args() {
  }

  virtual ~ChatService_GetUserList_args() throw();

  bool operator == (const ChatService_GetUserList_args & /* rhs */) const
  {
    return true;
  }
  bool operator != (const ChatService_GetUserList_args &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const ChatService_GetUserList_args & ) const;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};


class ChatService_GetUserList_pargs {
 public:


  virtual ~ChatService_GetUserList_pargs() throw();

  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};

typedef struct _ChatService_GetUserList_result__isset {
  _ChatService_GetUserList_result__isset() : success(false) {}
  bool success :1;
} _ChatService_GetUserList_result__isset;

class ChatService_GetUserList_result {
 public:

  ChatService_GetUserList_result(const ChatService_GetUserList_result&);
  ChatService_GetUserList_result& operator=(const ChatService_GetUserList_result&);
  ChatService_GetUserList_result() {
  }

  virtual ~ChatService_GetUserList_result() throw();
  std::set<std::string>  success;

  _ChatService_GetUserList_result__isset __isset;

  void __set_success(const std::set<std::string> & val);

  bool operator == (const ChatService_GetUserList_result & rhs) const
  {
    if (!(success == rhs.success))
      return false;
    return true;
  }
  bool operator != (const ChatService_GetUserList_result &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const ChatService_GetUserList_result & ) const;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};

typedef struct _ChatService_GetUserList_presult__isset {
  _ChatService_GetUserList_presult__isset() : success(false) {}
  bool success :1;
} _ChatService_GetUserList_presult__isset;

class ChatService_GetUserList_presult {
 public:


  virtual ~ChatService_GetUserList_presult() throw();
  std::set<std::string> * success;

  _ChatService_GetUserList_presult__isset __isset;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);

};

typedef struct _ChatService_SendDirectMessage_args__isset {
  _ChatService_SendDirectMessage_args__isset() : message(false), toUserName(false) {}
  bool message :1;
  bool toUserName :1;
} _ChatService_SendDirectMessage_args__isset;

class ChatService_SendDirectMessage_args {
 public:

  ChatService_SendDirectMessage_args(const ChatService_SendDirectMessage_args&);
  ChatService_SendDirectMessage_args& operator=(const ChatService_SendDirectMessage_args&);
  ChatService_SendDirectMessage_args() : message(), toUserName() {
  }

  virtual ~ChatService_SendDirectMessage_args() throw();
  std::string message;
  std::string toUserName;

  _ChatService_SendDirectMessage_args__isset __isset;

  void __set_message(const std::string& val);

  void __set_toUserName(const std::string& val);

  bool operator == (const ChatService_SendDirectMessage_args & rhs) const
  {
    if (!(message == rhs.message))
      return false;
    if (!(toUserName == rhs.toUserName))
      return false;
    return true;
  }
  bool operator != (const ChatService_SendDirectMessage_args &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const ChatService_SendDirectMessage_args & ) const;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};


class ChatService_SendDirectMessage_pargs {
 public:


  virtual ~ChatService_SendDirectMessage_pargs() throw();
  const std::string* message;
  const std::string* toUserName;

  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};

typedef struct _ChatService_SendBroadcastMessage_args__isset {
  _ChatService_SendBroadcastMessage_args__isset() : message(false) {}
  bool message :1;
} _ChatService_SendBroadcastMessage_args__isset;

class ChatService_SendBroadcastMessage_args {
 public:

  ChatService_SendBroadcastMessage_args(const ChatService_SendBroadcastMessage_args&);
  ChatService_SendBroadcastMessage_args& operator=(const ChatService_SendBroadcastMessage_args&);
  ChatService_SendBroadcastMessage_args() : message() {
  }

  virtual ~ChatService_SendBroadcastMessage_args() throw();
  std::string message;

  _ChatService_SendBroadcastMessage_args__isset __isset;

  void __set_message(const std::string& val);

  bool operator == (const ChatService_SendBroadcastMessage_args & rhs) const
  {
    if (!(message == rhs.message))
      return false;
    return true;
  }
  bool operator != (const ChatService_SendBroadcastMessage_args &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const ChatService_SendBroadcastMessage_args & ) const;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};


class ChatService_SendBroadcastMessage_pargs {
 public:


  virtual ~ChatService_SendBroadcastMessage_pargs() throw();
  const std::string* message;

  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};

class ChatServiceClient : virtual public ChatServiceIf {
 public:
  ChatServiceClient(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> prot) {
    setProtocol(prot);
  }
  ChatServiceClient(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> iprot, boost::shared_ptr< ::apache::thrift::protocol::TProtocol> oprot) {
    setProtocol(iprot,oprot);
  }
 private:
  void setProtocol(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> prot) {
  setProtocol(prot,prot);
  }
  void setProtocol(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> iprot, boost::shared_ptr< ::apache::thrift::protocol::TProtocol> oprot) {
    piprot_=iprot;
    poprot_=oprot;
    iprot_ = iprot.get();
    oprot_ = oprot.get();
  }
 public:
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> getInputProtocol() {
    return piprot_;
  }
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> getOutputProtocol() {
    return poprot_;
  }
  void Connect(const std::string& userName);
  void send_Connect(const std::string& userName);
  void recv_Connect();
  void Ping();
  void send_Ping();
  void Disconnect();
  void send_Disconnect();
  void GetUserList(std::set<std::string> & _return);
  void send_GetUserList();
  void recv_GetUserList(std::set<std::string> & _return);
  void SendDirectMessage(const std::string& message, const std::string& toUserName);
  void send_SendDirectMessage(const std::string& message, const std::string& toUserName);
  void SendBroadcastMessage(const std::string& message);
  void send_SendBroadcastMessage(const std::string& message);
 protected:
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> piprot_;
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> poprot_;
  ::apache::thrift::protocol::TProtocol* iprot_;
  ::apache::thrift::protocol::TProtocol* oprot_;
};

class ChatServiceProcessor : public ::apache::thrift::TDispatchProcessor {
 protected:
  boost::shared_ptr<ChatServiceIf> iface_;
  virtual bool dispatchCall(::apache::thrift::protocol::TProtocol* iprot, ::apache::thrift::protocol::TProtocol* oprot, const std::string& fname, int32_t seqid, void* callContext);
 private:
  typedef  void (ChatServiceProcessor::*ProcessFunction)(int32_t, ::apache::thrift::protocol::TProtocol*, ::apache::thrift::protocol::TProtocol*, void*);
  typedef std::map<std::string, ProcessFunction> ProcessMap;
  ProcessMap processMap_;
  void process_Connect(int32_t seqid, ::apache::thrift::protocol::TProtocol* iprot, ::apache::thrift::protocol::TProtocol* oprot, void* callContext);
  void process_Ping(int32_t seqid, ::apache::thrift::protocol::TProtocol* iprot, ::apache::thrift::protocol::TProtocol* oprot, void* callContext);
  void process_Disconnect(int32_t seqid, ::apache::thrift::protocol::TProtocol* iprot, ::apache::thrift::protocol::TProtocol* oprot, void* callContext);
  void process_GetUserList(int32_t seqid, ::apache::thrift::protocol::TProtocol* iprot, ::apache::thrift::protocol::TProtocol* oprot, void* callContext);
  void process_SendDirectMessage(int32_t seqid, ::apache::thrift::protocol::TProtocol* iprot, ::apache::thrift::protocol::TProtocol* oprot, void* callContext);
  void process_SendBroadcastMessage(int32_t seqid, ::apache::thrift::protocol::TProtocol* iprot, ::apache::thrift::protocol::TProtocol* oprot, void* callContext);
 public:
  ChatServiceProcessor(boost::shared_ptr<ChatServiceIf> iface) :
    iface_(iface) {
    processMap_["Connect"] = &ChatServiceProcessor::process_Connect;
    processMap_["Ping"] = &ChatServiceProcessor::process_Ping;
    processMap_["Disconnect"] = &ChatServiceProcessor::process_Disconnect;
    processMap_["GetUserList"] = &ChatServiceProcessor::process_GetUserList;
    processMap_["SendDirectMessage"] = &ChatServiceProcessor::process_SendDirectMessage;
    processMap_["SendBroadcastMessage"] = &ChatServiceProcessor::process_SendBroadcastMessage;
  }

  virtual ~ChatServiceProcessor() {}
};

class ChatServiceProcessorFactory : public ::apache::thrift::TProcessorFactory {
 public:
  ChatServiceProcessorFactory(const ::boost::shared_ptr< ChatServiceIfFactory >& handlerFactory) :
      handlerFactory_(handlerFactory) {}

  ::boost::shared_ptr< ::apache::thrift::TProcessor > getProcessor(const ::apache::thrift::TConnectionInfo& connInfo);

 protected:
  ::boost::shared_ptr< ChatServiceIfFactory > handlerFactory_;
};

class ChatServiceMultiface : virtual public ChatServiceIf {
 public:
  ChatServiceMultiface(std::vector<boost::shared_ptr<ChatServiceIf> >& ifaces) : ifaces_(ifaces) {
  }
  virtual ~ChatServiceMultiface() {}
 protected:
  std::vector<boost::shared_ptr<ChatServiceIf> > ifaces_;
  ChatServiceMultiface() {}
  void add(boost::shared_ptr<ChatServiceIf> iface) {
    ifaces_.push_back(iface);
  }
 public:
  void Connect(const std::string& userName) {
    size_t sz = ifaces_.size();
    size_t i = 0;
    for (; i < (sz - 1); ++i) {
      ifaces_[i]->Connect(userName);
    }
    ifaces_[i]->Connect(userName);
  }

  void Ping() {
    size_t sz = ifaces_.size();
    size_t i = 0;
    for (; i < (sz - 1); ++i) {
      ifaces_[i]->Ping();
    }
    ifaces_[i]->Ping();
  }

  void Disconnect() {
    size_t sz = ifaces_.size();
    size_t i = 0;
    for (; i < (sz - 1); ++i) {
      ifaces_[i]->Disconnect();
    }
    ifaces_[i]->Disconnect();
  }

  void GetUserList(std::set<std::string> & _return) {
    size_t sz = ifaces_.size();
    size_t i = 0;
    for (; i < (sz - 1); ++i) {
      ifaces_[i]->GetUserList(_return);
    }
    ifaces_[i]->GetUserList(_return);
    return;
  }

  void SendDirectMessage(const std::string& message, const std::string& toUserName) {
    size_t sz = ifaces_.size();
    size_t i = 0;
    for (; i < (sz - 1); ++i) {
      ifaces_[i]->SendDirectMessage(message, toUserName);
    }
    ifaces_[i]->SendDirectMessage(message, toUserName);
  }

  void SendBroadcastMessage(const std::string& message) {
    size_t sz = ifaces_.size();
    size_t i = 0;
    for (; i < (sz - 1); ++i) {
      ifaces_[i]->SendBroadcastMessage(message);
    }
    ifaces_[i]->SendBroadcastMessage(message);
  }

};

// The 'concurrent' client is a thread safe client that correctly handles
// out of order responses.  It is slower than the regular client, so should
// only be used when you need to share a connection among multiple threads
class ChatServiceConcurrentClient : virtual public ChatServiceIf {
 public:
  ChatServiceConcurrentClient(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> prot) {
    setProtocol(prot);
  }
  ChatServiceConcurrentClient(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> iprot, boost::shared_ptr< ::apache::thrift::protocol::TProtocol> oprot) {
    setProtocol(iprot,oprot);
  }
 private:
  void setProtocol(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> prot) {
  setProtocol(prot,prot);
  }
  void setProtocol(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> iprot, boost::shared_ptr< ::apache::thrift::protocol::TProtocol> oprot) {
    piprot_=iprot;
    poprot_=oprot;
    iprot_ = iprot.get();
    oprot_ = oprot.get();
  }
 public:
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> getInputProtocol() {
    return piprot_;
  }
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> getOutputProtocol() {
    return poprot_;
  }
  void Connect(const std::string& userName);
  int32_t send_Connect(const std::string& userName);
  void recv_Connect(const int32_t seqid);
  void Ping();
  void send_Ping();
  void Disconnect();
  void send_Disconnect();
  void GetUserList(std::set<std::string> & _return);
  int32_t send_GetUserList();
  void recv_GetUserList(std::set<std::string> & _return, const int32_t seqid);
  void SendDirectMessage(const std::string& message, const std::string& toUserName);
  void send_SendDirectMessage(const std::string& message, const std::string& toUserName);
  void SendBroadcastMessage(const std::string& message);
  void send_SendBroadcastMessage(const std::string& message);
 protected:
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> piprot_;
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> poprot_;
  ::apache::thrift::protocol::TProtocol* iprot_;
  ::apache::thrift::protocol::TProtocol* oprot_;
  ::apache::thrift::async::TConcurrentClientSyncInfo sync_;
};

#ifdef _WIN32
  #pragma warning( pop )
#endif

} // namespace

#endif
